﻿Imports PW.JSON

Module Module1

    Class Prova

        Private _id As Integer
        Private _name As String
        Private _valido As Boolean
        Private _subObject As Prova
        Private _numero As Integer
        Private _numeroDec As Double
        Private _array() As String

        Public Property ID() As Integer
            Get
                Return _id
            End Get
            Set(ByVal value As Integer)
                _id = value
            End Set
        End Property

        Public Property Name() As String
            Get
                Return _name
            End Get
            Set(ByVal value As String)
                _name = value
            End Set
        End Property

        Public Property Valido() As Boolean
            Get
                Return _valido
            End Get
            Set(ByVal value As Boolean)
                _valido = value
            End Set
        End Property

        Public Property SubObject() As Prova
            Get
                Return _subObject
            End Get
            Set(ByVal value As Prova)
                _subObject = value
            End Set
        End Property

        Public Property NumeroDec() As Double
            Get
                Return _numeroDec
            End Get
            Set(ByVal value As Double)
                _numeroDec = value
            End Set
        End Property

        Public Property Array() As String()
            Get
                Return _array
            End Get
            Set(ByVal value As String())
                _array = value
            End Set
        End Property

        Public Sub New()

        End Sub

        Public Sub New(ByVal ID As Integer, ByVal Name As String)
            _id = ID
            _name = Name
        End Sub

        Public Function SomeMethod() As String
            Return "Method: " & _id
        End Function

    End Class

    Sub Main()

        Test_ObjectToString()

        Test_StringToObject()

    End Sub

    Sub Test_ObjectToString()
        Dim objprova As New Prova(1, "Nome Object")
        objprova.Array = Split("A E I O U")
        objprova.NumeroDec = 100.34
        objprova.SubObject = New Prova(2, "Nome - SubObject")
        objprova.Valido = True
        Console.WriteLine(PW.JSON.JSONHelper.ObjectToString(objprova))

        Console.WriteLine("__________________________")
        Console.WriteLine("Press Enter to continue...")
        Console.ReadLine()
    End Sub

    Sub Test_StringToObject()
        Dim strJSON As String = "{""NumeroDec"": 100.34, ""Name"": ""Nome Object"", " & _
                        " ""Array"": [""A"", ""E"", ""I"", ""O"", ""U""], " & _
                        " ""SubObject"": {""NumeroDec"": 0, ""Name"": ""Nome - SubObject"", " & _
                        " ""Array"": null, ""SubObject"": null, ""Valido"": false, ""ID"": 2}, " & _
                        " ""Valido"": true, ""ID"": 1}"

        Dim objprova As Prova
        objprova = PW.JSON.JSONHelper.StringToObject(strJSON, GetType(Prova))

        Console.WriteLine(objprova.Name)
        Console.WriteLine(objprova.SubObject.Name)

        Console.WriteLine("__________________________")
        Console.WriteLine("Press Enter to continue...")
        Console.ReadLine()
    End Sub

End Module

